c
c  Prelev:  1 :  rowsng
c           2 :  colsng
c           4 :  rowact
c           8 :  chepdu
c          16 :  duchek
c          32 :  bndchk
c          64 :  splchk
c         128 :  freagr
c         256 :  sparse
c         512 :  xduchk
c
c ========================================================================
c
      subroutine presol(colpnt,colidx,colnzs,rowidx,rownzs,
     x collst,rowlst,colmrk,rowmrk,colsta,rowsta,
     x colbeg,colend,rowbeg,rowend,
     x vartyp,pmaxr,pminr,pmbig,ppbig,
     x upperb,lowerb,upslck,loslck,rhs,obj,prehis,prelen,
     x addobj,big,list,mrk,
     x dulo,duup,dmaxc,dminc,dmbig,dpbig,prelev,code)
c
      common/dims/ n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
      integer*4    n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
c
      integer*4 colpnt(n1),colidx(nz),rowidx(nz),
     x collst(n),rowlst(m),pmbig(m),ppbig(m),
     x colbeg(n),colend(n),rowbeg(m),rowend(m),
     x colmrk(n),rowmrk(m),colsta(n),rowsta(m),
     x list(mn),mrk(mn),prehis(mn),prelen,prelev,code,
     x dpbig(n),dmbig(n),vartyp(n)
      real*8    colnzs(nz),rownzs(nz),pmaxr(m),pminr(m),addobj,
     x upperb(n),lowerb(n),upslck(m),loslck(m),rhs(m),obj(n),
     x dulo(m),duup(m),dmaxc(n),dminc(n),big
c
      integer*4 i,j,k,p,o,pnt1,pnt2,pass,cnum,procn,rnum,coln,rown
      real*8    sol,up,lo,tfeas,zero,lbig,bigbou,dbigbo
      integer*4 dusrch,bndsrc,bndchg
      character*99 buff
c
c initialize : clean up the matrix and set-up row-wise structure
c
      tfeas  = 1.0d-08
      zero   = 1.0d-15
      dusrch =  10
      bndsrc =   5
      bndchg =   6
      bigbou = 1.0d+5
      dbigbo = 1.0d+5
c
      lbig = big*0.9d+0
      pass=0
      rown=0
      coln=0
      cnum=0
      rnum=0
      do i=1,mn
        mrk(i)=-1
      enddo
      do i=1,m
        pmaxr(i)=0.0d+0
        pminr(i)=0.0d+0
        pmbig(i)=0
        ppbig(i)=0
        rowend(i)=0
        if(rowsta(i).gt.-2)then
          rown=rown+1
          rowlst(rown)=i
          rowmrk(i)=0
        endif
      enddo
      do i=1,n
        dmaxc(i)=0.0d+0
        dminc(i)=0.0d+0
        dmbig(i)=0
        dpbig(i)=0
        if(colsta(i).gt.-2)then
          coln=coln+1
          collst(coln)=i
          colmrk(i)=0
          pnt1=colpnt(i)
          pnt2=colpnt(i+1)-1
          p=pnt2
          do j=pnt2,pnt1,-1
           if((rowsta(colidx(j)).le.-2).or.(abs(colnzs(j)).lt.zero))then
             o=colidx(j)
             sol=colnzs(j)
             colidx(j)=colidx(p)
             colnzs(j)=colnzs(p)
             colidx(p)=o
             colnzs(p)=sol
             p=p-1
           else
             rowend(colidx(j))=rowend(colidx(j))+1
           endif
          enddo
          colbeg(i)=pnt1
          colend(i)=p
        endif
      enddo
      pnt1=1
      do j=1,rown
        i=rowlst(j)
        rowbeg(i)=pnt1
        pnt1=pnt1+rowend(i)
        rowend(i)=rowbeg(i)-1
      enddo
      do k=1,coln
        i=collst(k)
        pnt1=colbeg(i)
        pnt2=colend(i)
        do j=pnt1,pnt2
          rowend(colidx(j))=rowend(colidx(j))+1
          rowidx(rowend(colidx(j)))=i
          rownzs(rowend(colidx(j)))=colnzs(j)
        enddo
      enddo
c
c Initialize the minimum and maximum row activity
c
      sol=0.9d+0*big
      o=1
      do j=1,coln
        i=collst(j)
        pnt1=colbeg(i)
        pnt2=colend(i)
        up=upperb(i)
        lo=lowerb(i)
        call chgmxm(pnt1,pnt2,up,lo,colidx,colnzs,
     x  ppbig,pmaxr,pmbig,pminr,sol,o,m)
      enddo
c
c Start Presolve sequence: Step 1 : ROW SINGLETONS
c
  10  procn=1
      call setlst(n,m,nz,rown,rowlst,rowmrk,coln,collst,colmrk,
     x procn,rowsta,colsta,rowbeg,rowend,cnum,list,mrk,pass,
     x colbeg,colend,colidx)
      if(coln+rown.eq.0)goto 50
      if((iand(prelev,1).gt.0).and.(cnum.gt.0))then
        call rowsng(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  coln,collst,colmrk,rown,rowlst,rowmrk,
     x  cnum,list,mrk,procn,
     x  ppbig,pmaxr,pmbig,pminr,
     x  lbig,tfeas,zero,code)
        if(code.gt.0)goto 100
      endif
c
c Step 2 : COLUMN SINGLETONS
c
      procn=2
      call setlst(m,n,nz,coln,collst,colmrk,rown,rowlst,rowmrk,
     x procn,colsta,rowsta,colbeg,colend,cnum,list,mrk,pass,
     x rowbeg,rowend,rowidx)
      if(coln+rown.eq.0)goto 50
      if((iand(prelev,2).gt.0).and.(cnum.gt.0))then
        call colsng(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  coln,collst,colmrk,
     x  cnum,list,mrk,procn,
     x  ppbig,pmaxr,pmbig,pminr,
     x  lbig,tfeas,zero,code)
        if(code.gt.0)goto 100
      endif
c
c Step 3 : ROW ACTIVITY CHECK
c
      procn=3
      call setlst(n,m,nz,rown,rowlst,rowmrk,coln,collst,colmrk,
     x procn,rowsta,colsta,rowbeg,rowend,cnum,list,mrk,pass,
     x colbeg,colend,colidx)
      if(coln+rown.eq.0)goto 50
      if((iand(prelev,4).gt.0).and.(cnum.gt.0))then
        call rowact(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  coln,collst,colmrk,rown,rowlst,rowmrk,
     x  cnum,list,mrk,procn,
     x  ppbig,pmaxr,pmbig,pminr,
     x  lbig,tfeas,code)
        if(code.gt.0)goto 100
      endif
c
c Step 4 : CHEAP DUAL TEST
c
      procn=4
      call setlst(m,n,nz,coln,collst,colmrk,rown,rowlst,rowmrk,
     x procn,colsta,rowsta,colbeg,colend,cnum,list,mrk,pass,
     x rowbeg,rowend,rowidx)
      if(coln+rown.eq.0)goto 50
      if((iand(prelev,8).gt.0).and.(cnum.gt.0))then
        call chepdu(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  coln,collst,colmrk,rown,rowlst,rowmrk,
     x  cnum,list,mrk,procn,
     x  ppbig,pmaxr,pmbig,pminr,
     x  lbig,zero,code)
        if(code.gt.0)goto 100
      endif
c
c Step 5 : USUAL DUAL TEST
c
      procn=5
      call setlst(n,m,nz,rown,rowlst,rowmrk,coln,collst,colmrk,
     x procn,rowsta,colsta,rowbeg,rowend,rnum,list(n+1),mrk(n+1),pass,
     x colbeg,colend,colidx)
c
c Remove zero entries at the first loop from the main list
c
      if (pass.eq.5)then
        k=1
   5    if(k.le.coln)then
          if(colmrk(collst(k)).eq.0)then
            colmrk(collst(k))=-1
            collst(k)=collst(coln)
            coln=coln-1
          else
            k=k+1
          endif
          goto 5
        endif
        k=1
  20    if(k.le.rown)then
          if(rowmrk(rowlst(k)).eq.0)then
            rowmrk(rowlst(k))=-1
            rowlst(k)=rowlst(rown)
            rown=rown-1
          else
            k=k+1
          endif
          goto 20
        endif
      endif
c
      if((iand(prelev,16).gt.0).and.(cnum+rnum.gt.0))then
        call duchek(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  coln,collst,colmrk,rown,rowlst,rowmrk,
     x  cnum,list,mrk,rnum,list(n+1),mrk(n+1),procn,
     x  ppbig,pmaxr,pmbig,pminr,
     x  dulo,duup,dmaxc,dminc,dpbig,dmbig,
     x  big,lbig,tfeas,zero,dbigbo,dusrch,code,prelev)
        if(code.gt.0)goto 100
      endif
      goto 10
c
c Bound check
c
  50  procn=6
      if(iand(prelev,32).gt.0)then
        call bndchk(n,m,mn,nz,
     x  colbeg,colend,colidx,colnzs,
     x  rowbeg,rowend,rowidx,rownzs,
     x  upperb,lowerb,upslck,loslck,
     x  rhs,obj,addobj,colsta,rowsta,prelen,prehis,
     x  cnum,list,mrk,procn,dmaxc,dminc,
     x  ppbig,pmaxr,pmbig,pminr,dpbig,dmbig,
     x  big,lbig,tfeas,bndsrc,bndchg,bigbou,code)
        if(code.gt.0)goto 100
      endif
c
c Finding splitted free variables
c
      procn=7
      if(iand(prelev,64).gt.0)then
       call coldbl(n,m,mn,nz,colbeg,colend,colidx,colnzs,
     x rowbeg,rowend,rowidx,rownzs,upperb,lowerb,obj,colsta,
     x prelen,prehis,procn,list,dmaxc,vartyp,big,lbig,tfeas,zero)
        if(code.gt.0)goto 100
      endif
      goto 999
c
c Infeasibility detected
c
 100  if(code.eq.3)then
        write(buff,'(1x,a)')'Dual infeasibility detected in presolve'
      else
        write(buff,'(1x,a)')'Primal infeasibility detected in presolve'
      endif
      call mprnt(buff)
      if (procn.eq.1)then
        write(buff,'(1x,a)')'Presolve process: Row singleton check'
      else if (procn.eq.2)then
        write(buff,'(1x,a)')'Presolve process: Column singleton check'
      else if (procn.eq.3)then
        write(buff,'(1x,a)')'Presolve process: Row activity check'
      else if (procn.eq.4)then
        write(buff,'(1x,a)')'Presolve process: Cheap dual check'
      else if (procn.eq.5)then
        write(buff,'(1x,a)')'Presolve process: Dual check'
      else if (procn.eq.6)then
        write(buff,'(1x,a)')'Presolve process: Bound check'
      else if (procn.eq.7)then
        write(buff,'(1x,a)')'Presolve process: Splitcol check'
      endif
      call mprnt(buff)
c
  999 return
      end
c
c ============================================================================
c
      subroutine chgmxm(pnt1,pnt2,upper,lower,idx,nonzrs,
     x pbig,maxr,mbig,minr,lbig,dir,siz)
C
      common/dims/ n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
      integer*4    n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
c
c This subroutine changes/updates the minimum/maximum row activity
c values
c
      integer*4 siz,pnt1,pnt2,idx(nz),pbig(siz),mbig(siz),dir
      real*8    upper,lower,nonzrs(nz),maxr(siz),minr(siz),lbig
c
      integer*4 j,k
      real*8 s
c
      do j=pnt1,pnt2
        k=idx(j)
        s=nonzrs(j)
        if(s.gt.0d+0)then
          if(upper.ge.lbig)then
            pbig(k)=pbig(k)+dir
          else
            maxr(k)=maxr(k)+upper*s*dble(dir)
          endif
          if(lower.le.-lbig)then
            mbig(k)=mbig(k)+dir
          else
            minr(k)=minr(k)+lower*s*dble(dir)
          endif
        else
          if(upper.ge.lbig)then
            mbig(k)=mbig(k)+dir
          else
            minr(k)=minr(k)+upper*s*dble(dir)
          endif
          if(lower.le.-lbig)then
            pbig(k)=pbig(k)+dir
          else
            maxr(k)=maxr(k)+lower*s*dble(dir)
          endif
        endif
      enddo
      return
      end
c
c ============================================================================
c
      subroutine modmxm(nz,pnt1,pnt2,oldb,newb,rowidx,nonzeros,
     x pbig,maxr,mbig,minr,lbig,dir,siz)
c
c This subroutine modifies the row (column) activity values
c from an old bound (oldb) to a new one (newb)
c dir= 1 update on upper bound
c dir=-1 update on lower bound
c
      integer*4 nz,siz,pnt1,pnt2,rowidx(nz),pbig(siz),mbig(siz),dir
      real*8    oldb,newb,nonzeros(nz),maxr(siz),minr(siz),lbig
c
      integer*4 f,j,k
      real*8 s,diff
c
      f=0
      diff=newb-oldb
      if(abs(oldb).gt.lbig)then
        diff=newb
        f=1
        if(oldb.gt.0.0d+0)then
          dir=1
        else
          dir=-1
        endif
        do j=pnt1,pnt2
          k=rowidx(j)
          if((nonzeros(j)*dble(dir)).gt.0.0d+0)then
            pbig(k)=pbig(k)-1
          else
            mbig(k)=mbig(k)-1
          endif
        enddo
      endif
      if(abs(newb).gt.lbig)then
        diff=-oldb
        f=f+2
        if(newb.gt.0)then
          dir=1
        else
          dir=-1
        endif
        do j=pnt1,pnt2
          k=rowidx(j)
          if((nonzeros(j)*dble(dir)).gt.0.0)then
            pbig(k)=pbig(k)+1
          else
            mbig(k)=mbig(k)+1
          endif
        enddo
      endif
      if(f.lt.3)then
        do j=pnt1,pnt2
          k=rowidx(j)
          s=nonzeros(j)
          if(s.gt.0.0d+0)then
            if(dir.eq.1)then
              maxr(k)=maxr(k)+diff*s
            else
              minr(k)=minr(k)+diff*s
            endif
          else
            if(dir.eq.1)then
              minr(k)=minr(k)+diff*s
            else
              maxr(k)=maxr(k)+diff*s
            endif
          endif
        enddo
      endif
      return
      end
c
c ============================================================================
c
      subroutine remove(m,n,nz,col,colidx,colnzs,rowidx,rownzs,
     x colbeg,colend,rowbeg,rowend,rhs,pivot,traf)
c
c This subroutine removes a column from the row-wise representation
c and updates the right-hand side, if parameter traf is set
c
      integer*4 m,n,nz,col,colidx(nz),rowidx(nz),
     x colbeg(n),colend(n),rowbeg(m),rowend(m)
      real*8    rhs(m),pivot,colnzs(nz),rownzs(nz)
      logical   traf
c
      integer*4 i,j,k,pnt1,pnt2
      real*8    sol
c
      do i=colbeg(col),colend(col)
        j=colidx(i)
        pnt1=rowbeg(j)
        pnt2=rowend(j)-1
        do k=pnt1,pnt2
          if(rowidx(k).eq.col)then
            sol=rownzs(k)
            rowidx(k)=rowidx(pnt2+1)
            rownzs(k)=rownzs(pnt2+1)
            rowidx(pnt2+1)=col
            rownzs(pnt2+1)=sol
            goto 10
          endif
        enddo
  10    rowend(j)=pnt2
      enddo
      if(traf)then
        do i=colbeg(col),colend(col)
          rhs(colidx(i))=rhs(colidx(i))-pivot*colnzs(i)
        enddo
      endif      
      return
      end
c
c =============================================================================
c
      subroutine setlst(m,n,nz,coln,collst,colmrk,rown,rowlst,rowmrk,
     x procn,colsta,rowsta,colbeg,colend,cnum,list,mrk,pass,
     x rowbeg,rowend,rowidx)
c
c This subroutine deletes entries from the main search list 
c and set-up the local search list for the presolv subprocesses.
c
      integer*4 m,n,nz,coln,collst(n),colmrk(n),procn,colsta(n),
     x cnum,list(n),mrk(n),pass,colbeg(n),colend(n),
     x rown,rowlst(m),rowmrk(m),rowsta(m),rowbeg(m),rowend(m),
     x rowidx(nz)
c
      integer*4 i,j,k,p1,p2
c
      pass=pass+1
      k=1
      cnum=0     
  10  if(k.le.coln)then
        i=collst(k)
        if((colsta(i).le.-2).or.(colmrk(i).eq.procn))then
          collst(k)=collst(coln)
          colmrk(i)=-procn
          coln=coln-1
        else
          k=k+1
          if((procn.le.2).and.(colbeg(i).ne.colend(i)))goto 10
          cnum=cnum+1
          list(cnum)=i
          mrk(i)=pass
        endif
        goto 10
      endif
c
      k=1
  20  if(k.le.rown)then
        i=rowlst(k)
        if((rowsta(i).le.-2).or.(rowmrk(i).eq.procn))then
          rowlst(k)=rowlst(rown)
          rowmrk(i)=-procn
          rown=rown-1
        else
          k=k+1
        endif
        goto 20
      endif
c
c Extend lists
c
      k=1
      do while (k.le.rown)
        p1=rowbeg(rowlst(k))
        p2=rowend(rowlst(k))
        do i=p1,p2
          j=rowidx(i)
          if((mrk(j).lt.0).and.
     x    ((procn.gt.2).or.(colbeg(j).eq.colend(j))))then
            mrk(j)=procn
            cnum=cnum+1
            list(cnum)=j
          endif
        enddo
        k=k+1
      enddo
c
      return
      end
c
c ==========================================================================
