c ===========================================================================
c
      subroutine symmfo(inta1,pivots,ecolpnt,vcstat,
     x colpnt,rowidx,rowpnt,colindex,perm,invperm,
     x count,inta2,inta3,inta4,inta5,inta6,inta7,inta8,inta9,
     x inta10,inta11,nonzeros,l,oper,tfind,inta12,code)
c
      common/dims/ n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
      integer*4    n,n1,m,mn,nz,cfree,pivotn,denwin,rfree
c
      integer*4 inta1(mn),ecolpnt(mn),pivots(mn),vcstat(mn),
     x colpnt(n1),rowidx(cfree),rowpnt(mn),colindex(rfree),
     x perm(mn),invperm(mn),count(mn),inta2(mn),inta3(mn),inta4(mn),
     x inta5(mn),inta6(mn),inta7(mn),inta8(mn),inta9(mn),inta10(mn),
     x inta11(mn),tfind,inta12(mn),l,code
c
      real*8   nonzeros(cfree),oper
c
      integer*4 i,j,k,t1,tt1,t2,p1,p2,pnt,pnt1,pnt2,aatnz
      character*99 buff
c
c ---------------------------------------------------------------------------
c
    1 format(1x,'Building aat                 time:',f9.2,' sec')
    2 format(1x,'Building ordering    list    time:',f9.2,' sec')
    4 format(1x,'Symbolic factorisation       time:',f9.2,' sec')
    5 format(1x,'Total symbolic phase         time:',f9.2,' sec')
    6 format(1x,'Sub-diagonal nonzeros in aat     :',i9)
    7 format(1x,'Sub-diagonal nonzeros in L       :',i9)
    8 format(1x,'NONZEROS         :',i12)
    9 format(1x,'OPERATIONS       :',f13.0)
   10 format(1x,'Minimum Local Fill-in Ordering with Power:',i3)
   11 format(1x,'Minimum Degree Ordering (Power=0)')
   12 format(1x,'Without Ordering')
c
      call timer (tt1)
      if(tfind.lt.0)then
        write(buff,12)
      else if(tfind.eq.0)then
        write(buff,11)
      else
        write(buff,10)tfind
      endif
      oper=0.0d+0
      call mprnt(buff)
      do i=1,nz
        rowidx(i)=rowidx(i)-n
      enddo
      if(rfree.lt.nz)then
        write(buff,'(1x,a)')'Not enough integer memory'
        call mprnt(buff)
        code=-2
        goto 999
      endif
      if(cfree.lt.2*nz)then
        write(buff,'(1x,a)')'Not enough real memory'
        call mprnt(buff)
        code=-2
        goto 999
      endif
c
c If no ordering...
c
      if(tfind.lt.0)then
        t2=tt1
        do i=1,m
          perm(i)=i
        enddo
        goto 50
      endif
c
c Otherwise...
c
      do i=1,n
        inta2(i)=i
      enddo
      call transps(n,m,nz,colpnt,rowidx,nonzeros,
     x rowpnt,colindex,nonzeros(nz+1),inta2)
      k=1
      l=m
      do i=1,m
        pivots(i)=0
        if(vcstat(i+n).le.-2)then
          invperm(l)=i
          l=l-1
        else
          invperm(k)=i
          k=k+1
        endif
      enddo
      call transps(m,n,nz,rowpnt,colindex,nonzeros(nz+1),
     x colpnt,rowidx,nonzeros,invperm)
      do i=1,n
        p1=colpnt(i)
        if(vcstat(i).le.-2)then
          p2=colpnt(i)-1
        else
          p2=colpnt(i+1)-1
  19      if((p1.le.p2).and.(vcstat(rowidx(p2)+n).le.-2))then
            p2=p2-1
            goto 19
          endif
        endif
        perm(i)=p1
        invperm(i)=p2
      enddo
c
      pnt=nz+1
      do i=1,m
        if(pnt+mn.gt.cfree)then
          write(buff,'(1x,a)')'Not enough real memory'
          call mprnt(buff)
          code=-2
          goto 999
        endif
        pivots(i)=1
        if(vcstat(i+n).gt.-2)then
          ecolpnt(i)=pnt
          pnt1=rowpnt(i)
          pnt2=rowpnt(i+1)-1
          do j=pnt1,pnt2
            k=colindex(j)
            if(vcstat(k).gt.-2)then
              p1=perm(k)
              p2=invperm(k)
              perm(k)=perm(k)+1
              do l=p1,p2
                if(pivots(rowidx(l)).eq.0)then
                  pivots(rowidx(l))=1
                  rowidx(pnt)=rowidx(l)
                  pnt=pnt+1
                endif
              enddo
            endif
          enddo
          count(i)=pnt-ecolpnt(i)
          do j=ecolpnt(i),pnt-1
            pivots(rowidx(j))=0
          enddo
        endif
      enddo
      aatnz=pnt-nz-1
c
c
      call timer (t2)
      write(buff,1)dble(t2-tt1)/100.0d+0
      call mprnt(buff)
c
c call minimum fill-in ordering
c
      call genmfo(m,mn,nz,cfree,rfree,pivotn,
     x ecolpnt,count,perm,rowpnt,vcstat(n+1),rowidx,
     x invperm,inta1,inta2,inta3,inta4,inta5,inta6,inta7,
     x inta8,inta9,inta10,inta11,colindex,tfind,inta12,pivots,code)
      if(code.lt.0)goto 999
c
c
 50   call timer(t1)
      write(buff,2)dble(t1-t2)/100.0d+0
      call mprnt(buff)
c
      pivotn=0
      do 30 i=1,n
        ecolpnt(i)=colpnt(i)
        count(i)=colpnt(i+1)-1
        inta2(i)=i
        if(vcstat(i).le.-2)goto 30
        pivotn=pivotn+1
        pivots(pivotn)=i
  30  continue
c
      call transps(n,m,nz,colpnt,rowidx,nonzeros,
     x rowpnt,colindex,nonzeros(nz+1),inta2)
c
      k=1
      l=m
      do 40 i=1,m
        j=perm(i)
        if(vcstat(j+n).le.-2)then
          invperm(l)=j
          l=l-1
        else
          pivotn=pivotn+1
          pivots(pivotn)=j+n
          invperm(k)=j
          k=k+1
        endif
  40  continue
c
      call transps(m,n,nz,rowpnt,colindex,nonzeros(nz+1),
     x colpnt,rowidx,nonzeros,invperm)
c
      do 20 i=1,nz
        rowidx(i)=rowidx(i)+n
  20  continue
c
      do i=1,n
        if(vcstat(i).gt.-2)then
          k=ecolpnt(i)
          l=count(i)
  35      if((l.ge.k).and.(vcstat(rowidx(l)).le.-2))then
            l=l-1
            goto 35
          endif
          count(i)=l
        endif
      enddo
c
      call symfact(pivots,rowidx,ecolpnt,count,vcstat,
     x perm,invperm,inta2,inta1,l,code)
      if(code.lt.0)goto 999
      call timer(t2)
      write(buff,4)dble(t2-t1)/100.0d+0
      call mprnt(buff)
      if(tfind.ge.0)then
        write(buff,6)aatnz
        call mprnt(buff)
      endif
      write(buff,7)l
      call mprnt(buff)
c
      do 55 i=1,mn
        inta1(i)=0
  55  continue
      l=0
      do 60 i=1,pivotn
        j=pivots(pivotn-i+1)
        k=count(j)-ecolpnt(j)+1
        if(k.eq.0)goto 60
        l=l+k
        inta1(j)=inta1(rowidx(ecolpnt(j)))+k
        oper=oper+(dble(k)*dble(k)+dble(k))/2.0d+0
  60  continue
      call timer(t1)
      write(buff,5)dble(t2-tt1)/100.0d+0
      call mprnt(buff)
      write(buff,8)l
      call mprnt(buff)
      write(buff,9)oper
      call mprnt(buff)
c
 999  return
      end
c
c ===========================================================================
